package org.drupal.project.recommender.algorithm;

import org.apache.mahout.cf.taste.common.TasteException;
import org.apache.mahout.cf.taste.impl.recommender.svd.ExpectationMaximizationSVDFactorizer;
import org.apache.mahout.cf.taste.impl.recommender.svd.Factorizer;
import org.apache.mahout.cf.taste.impl.recommender.svd.SVDRecommender;
import org.drupal.project.computing.DConnectionException;
import org.drupal.project.recommender.MahoutRecommender;

import java.sql.SQLException;

/**
 * SVD recommender.
 */
public class SVD extends MahoutRecommender {
    // TODO: make this configurable
    private final int NUM_FEATURES = 10; // 10 features should be big enough. might need to shrink for better noise-reduction.
    private final int NUM_ITERATIONS = 100;

    @Override
    protected void initSimilarity() {
        logger.info("Skip similarity for SVD algorithm.");
    }

    @Override
    protected void initRecommender() throws TasteException {
        // TODO: make this configurable
        Factorizer factorizer = new ExpectationMaximizationSVDFactorizer(dataModel, NUM_FEATURES, NUM_ITERATIONS);
        recommender = new SVDRecommender(dataModel, factorizer);
    }

    @Override
    protected void computeSimilarity() throws TasteException, SQLException {
        logger.info("Skip computing and saving similarity for SVD algorithm.");
    }

    @Override
    protected void computePrediction() throws TasteException, DConnectionException, SQLException {
        numPrediction = genericComputeSave(defaultPredictionHandler, dataModel.getUserIDs(), dataModel.getNumUsers(), "prediction", true);
    }
}
