<?php

/**
 * Implements hook_drush_command().
 */
function recommender_drush_command() {
  $items = array();
  $items['recommender'] = array(
    'description' => "Directly create a record to run recommender.",
    'aliases' => array('rec'),
    'drupal dependencies' => array('recommender'),
    'arguments' => array(
      'recommender'    => 'Recommender name to run.',
      'description' => 'Description of this command. Enclose spaces in double quotes.',
    ),
    'examples' => array(
      'drush recommender fivestar "Run fivestar recommender"' => "Create a request to run fivestar recommender."
    ),
    'bootstrap' => DRUSH_BOOTSTRAP_DRUPAL_FULL,
  );
  return $items;
}

/**
 * Implementation of hook_drush_help().
 */
function recommender_drush_help($section) {
  switch ($section) {
    case 'drush:recommender':
      return dt("Directly create a record to run recommender.");
  }
}

function drush_recommender($recommender, $description = NULL) {
  $record_id = recommender_create_record($recommender, $description);
  if ($record_id) {
    drush_print("Successfully created run-recommender request with computing_record ID: {$record_id}");
  }
  else {
    drush_print('Cannot create run-recommender request');
  }
}
